package com.gic.spark.datasource.entity;

import com.gic.spark.application.SparkEnvManager;
import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.Row;

import java.util.List;

/**
 * Created by paste on 2018/7/27 16:36
 * <p>
 * TODO: class description
 */
public abstract class DataSourceEntity {
    //    public static final int SOURCE_TYPE_MYSQL = 0;
//    public static final int SOURCE_TYPE_MYSQL_SHARDING = 1;
//    public static final int SOURCE_TYPE_MONGODB = 2;
//    public static final int SOURCE_TYPE_HIVE = 3;
    protected DataSourceType sourceType;

    public DataSourceType getSourceType() {
        return sourceType;
    }

    public abstract String getSourceKey();

    public abstract String getHiveTableName();

    public Dataset<Row> getDatasetByEnterpriseId(Integer enterpriseId) {
        return SparkEnvManager.getInstance().getSparkSession().sql(String.format("select * from %s where enterprise_id='%s'", getHiveTableName(), enterpriseId));
    }

    public abstract void extractDataToPartitionedHiveTable(List<Integer> enterpriseList);

}
